#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "io.h"
#include "json.h"
#include "def.h"


static void cut_version(char *buff, char *ver)
{
    int i = strlen(buff);
    int size = i;

    for(; i > 0; i--) {
        if(buff[i] == '-') break;
    }

    bzero(ver, size);
    strncpy(ver, buff+i+1, size-i-3);
}

static void split_cat_name(char *buff, char *cat, char *name)
{
    int size = strlen(buff);
    int i = 0;

    for(; i < size; i++) {
        if(buff[i] == '/') break;
    }

    bzero(cat, size);
    bzero(name, size);

    strncpy(cat, buff, i);
    strncpy(name, buff+i+1, size-i-2);
}

extern void build_pkg_info()
{
    char buff[BSIZE], cat[BSIZE], name[BSIZE], ver[BSIZE];

    enum {
        ST_INFO,
        ST_ORIG,
        ST_PATH
    } state = ST_INFO;

    FILE *INFO = popen("pkg_info -ao", "r");

    while(fgets(buff, BSIZE, INFO))
    {
        if(buff[0] == '\n') continue;

        switch(state)
        {
            case ST_INFO:
                cut_version(buff, ver);

                state = ST_ORIG;
                break;

            case ST_ORIG:
                state = ST_PATH;
                break;

            case ST_PATH:
                split_cat_name(buff, cat, name);
                set_pkg_info(cat, name, ver);

                state = ST_INFO;
                break;
        }
    }

    pclose(INFO);
}

extern void build_sys_info()
{
    char *sys, *ver, *arch;

    sys = uname("-s");
    if(strcmp(sys, "FreeBSD")) exit(1);

    ver = uname("-r");
    arch = uname("-p");

    set_sys_info(sys, ver, arch);

    free(sys);
    free(ver);
    free(arch);
}
